public class APList
{
  private ListNode front;    // first node of this list (null if empty)

  private int listSize;      // the number of elements in this list

  private int remIndex;      // the index of the remembered node

  private ListNode remNode;  // a reference to the node accessed by most recent call to get

  /**  Constructs an empty APList.
   */
  public APList()
  {
    front = null;
    remIndex = -1;
    remNode = null;
    listSize = 0;
  }

  /*** Part (a) ***/

  /** Gets a value at a given index in this list.
   *  @param n the index at which to get a value
   *         Precondition: 0 = n < size()
   *  @return the object at the given index
   *  Postcondition: The remembered node and index refer to the node at index n
   */
  public Object get(int n)
  {
    if (remIndex == -1 || remIndex > n)
    {
      remIndex = 0;
      remNode = front;
    }

    while (remIndex < n)
    {
      remNode = remNode.getNext();
      remIndex++;
    }

    return remNode.getValue();
  }

  /*** Part (b) ***/

  /** Adds a new node containing obj to the front of this list.
   *  @param obj the value to add to the list
   */
  public void addFirst(Object obj)
  {
    front = new ListNode(obj, front);
    listSize++;
    if (remIndex >= 0)
      remIndex++;  // adjustment for the new node added in front
    // Or:
    //   listSize++;
    //   remIndex++;
    //   if (remNode == null)
    //     remNode = front;
    // But the instructions say the method should not change the value of remNode...
  }

  /****************/

  /** @return the size of this list
   */
  public int size() { return listSize; }
}
