public class FilterTest
{
  /*** Part (b) ***/

  /** @param desirable contains strings that are allowed
   *         Precondition: desirable.length > 1
   *  @param notAllowed the string that is not allowed
   *  @return a Filter that accepts strings that contain at least one string
   *          in desirable and do not contain notAllowed.
   */
  public static Filter buildFilter(String[] desirable,
                                   String notAllowed)
  {
    OrFilter orF = new OrFilter(new SimpleFilter(desirable[0]),
                                new SimpleFilter(desirable[1]));
    for (int i = 2; i < desirable.length; i++)
      orF.add(new SimpleFilter(desirable[i]));

    NotFilter notF = new NotFilter(new SimpleFilter(notAllowed));

    return new AndFilter(orF, notF);
  }

  public static void main(String[] args)
  {
    String[] primary = {"red", "blue", "yellow"};
    Filter primaryColors = buildFilter(primary, "green");

    System.out.println(primaryColors.accept("Roses are red, violets are blue"));
    System.out.println(primaryColors.accept("blue grass is really green"));
    System.out.println(primaryColors.accept("The rainbow has many colors"));
  }
}
