import java.util.List;
import java.util.LinkedList;

  /*** Part (a) ***/

public class OrFilter implements Filter
{
  private List<Filter> filters;

  public OrFilter(Filter f1, Filter f2)
  {
    filters = new LinkedList<Filter>(); // or new ArrayList<Filter>
    filters.add(f1);
    filters.add(f2);
  }

  public void add(Filter f)
  {
    filters.add(f);
  }

  public boolean accept(String text)
  {
    for (Filter f : filters)
      if (f.accept(text))
        return true;
    return false;
  }
}
